{$DEFINE Zwei} {Berechnung des zweitbesten Zugs fr selektivere Zeiteinteilung}
{$DEFINE ZweiPlus} {Konsequente Bestimmung des zweitbesten Zugs, zustzliche Anzeigen}
{.$DEFINE Varianten} {verlangsamt das Programm deutlich; auch dann, wenn zur Laufzeit nur Standardschach gespielt wird}
{.$DEFINE Lernen}
program Feuerstein;

uses Windows;

CONST B=1; S=2; L=3; T=4; D=5; K=6; {Figuren}
TYPE FigFeld = Array[0..K] OF Integer;

CONST Stop = 1; Hintergrund = 2; unendlich = 4; Hauptzugdurch = 8; Anfang = 16; rechne = 32; {fr Zustand}
      ESchach = 1; EZwang = 2; EDruck = 4; EOpfer = 8; Erinnerung = 16; Nullzug = 32; {fr Wahl}
      PUCI = 1; PWinBoard = 2; {fr Protokoll}
      WHintergrund = 1; WAusgabe = 2; WPassiv = 4; {fr Winboard}
      StdWert : FigFeld = (0, 80+64, 300, 300, 480, 900, 2048);
{$IFDEF Varianten} ZhWert  : FigFeld = (0, 100+64, 200, 200, 200, 400, 2048);
      HandWert: FigFeld = (0, 32, 64, 48, 80, 128, 0); {$ENDIF}
      KListe : Array[0..7] OF Integer = (-17, 17, -15, 15, -16, 16, -1, 1);
      SListe : Array[0..7] OF Integer = (-33, 33, -31, 31, -18, 18, -14, 14);
      MobWert: Array[B..K] OF Integer = (8, 5, 5, 3, 1, 0);
      Aufstellung = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1';
      englisch = 'pnbrqk';

TYPE DBrett = Array[0..127] OF ShortInt;
     BListe = Array[0..7] OF ShortInt; {theoretisch bis zu 16 Angreifer mglich; ohne Umwandlungen: <= 10; Annahme hier: <= 8!!!}
     Bedroher = Array[0..127] OF BListe;
     PLage = ^Lage;
     Lage = RECORD {fast alles, was ber die derzeitige Position bekannt ist; die Chronik wird extern gefhrt}
              Anzug, Bewertung, EnPassant, Rochade, Zugnummer, Stillstand, Fortschritt : Integer;
              Merkwert{$IFDEF Varianten}, Bauernmaske{$ENDIF}: Int64;
              KPos, Material: Array[-1..1] OF Integer;
              Br   : DBrett; {erstes Brett: Schachbrett, zweites: Bauernwerte}
              Zahl : DBrett; {Anzahl der Angreifer der jeweiligen Farbe auf das Feld; erstes Brett: schwarz, zweites: wei}
              Ursprung: Bedroher; {Ursprung der "Angreifer", in der Form X SHL 4+Y (0: schwarz, 1: wei)}
            END;
    ZugwahlR = packed RECORD Zugwort, Sortierung: Integer; END;
    Zugtyp = packed RECORD Quelle, Ziel, Erweiterung, Fortschritt: Byte; END;
    Hirnzelle = packed RECORD
                   Wert : SmallInt;
                   tief: Byte;
                   Typ : ShortInt;
                   Bestzug : Integer;
                   MW : Int64;
                 END;
    THirn = ARRAY[0..67108863] OF Hirnzelle;
    TAnalyse = ARRAY[0..1023] OF Lage;

VAR Chronik : ARRAY[0..1023] OF Int64;
    Zobrist : ARRAY[0..1023] OF Int64; Zob : ARRAY[0..4095] OF Word Absolute Zobrist;
    Parameter : String;
    MatWert : FigFeld;
    {$IFDEF Varianten} Crazyhouse : Boolean; {$ENDIF}
    X : Cardinal;
    Zwei, Wahl, Zweitzug, ZWert, unscharf,
    {$IFDEF Varianten} Protokoll, Winboard, {$ENDIF} WZeit, SZeit,
    Beginn, Selektiv, Knoten, gemerkt, Restzeit, Grundwert, Eingabe, Ausgabe, Neuerung, Richtwert,
    LetztWert, LetztTiefe, HauptZug, HWert, Hirnmaske, Zustand : Integer;
    Analyse : ^TAnalyse;
    Hirn : ^THirn;
    {$IFDEF Lernen}Name: String; Status : Integer; {$ENDIF}

{---- Grundfunktionen ----}

FUNCTION vergangen : Integer; BEGIN vergangen := Integer(GetTickCount)-Beginn; END;

FUNCTION IntToStr(Wert: Integer): String;
VAR W : Integer;
BEGIN
  W := Abs(Wert); Result := '';
  REPEAT Result := Chr(W MOD 10+48)+Result; W := W DIV 10 UNTIL W = 0;
  IF Wert < 0 THEN Result := '-'+Result;
END;

FUNCTION StrToInt(CONST S:String):Integer; VAR I : Integer;
BEGIN Result := 0; FOR I := 1 TO Length(S) DO Result := Result*10+Ord(S[I])-48 END;

PROCEDURE Schreib(CONST Zeile:String);
  PROCEDURE sende(CONST S:String); BEGIN WriteFile(Ausgabe, S[1], Length(S), X, nil) END;
BEGIN sende(Zeile); sende(#10); END;

FUNCTION Trim(CONST S: String): String;
VAR I, L: Integer;
BEGIN
  L := Length(S); I := 1;
  WHILE (I <= L) DO IF (S[I] <= #32) THEN Inc(I) ELSE IF (S[L] <= #32) THEN Dec(L) ELSE Break;
  Result := Copy(S, I, L - I + 1)
end;

FUNCTION EntnimmBis(VAR S:String; CONST Wort: String): String;
VAR I : Integer;
BEGIN
  I := Pos(Wort+' ', S); IF I = 0 THEN I := Length(S)+1;
  Result := Copy(S, 1, I-1); S := Copy(S, I+Length(Wort), 32767);
  S := Trim(S); Result := Trim(Result);
END;

FUNCTION Entnimm(VAR S:String): String;
ASM MOV ECX, EDX; XOR EDX, EDX; CALL EntnimmBis END; {BEGIN Result := EntnimmBis(S, '') END;}

{---- Fehlersuche ----}

PROCEDURE Drucke(PL: PLage);

VAR A, X, Y, Z : Integer;
    S, St : String;

BEGIN WITH PL^ DO BEGIN
  FOR Y := 7 DOWNTO 0 DO
  BEGIN
    St := '';
    FOR X := 0 TO 7 DO
    BEGIN
      Z := Br[X SHL 4+Y];
      IF Z = 0 THEN S := '.'
      ELSE IF Z > 0 THEN S := UpCase(englisch[abs(Z)])
      ELSE S := englisch[-z];

      {$IFDEF Varianten} IF Odd(Bauernmaske SHR (X SHL 3+Y))
      THEN S := '('+S+')' ELSE {$ENDIF} S := ' '+S+' ';
      St := St + S + ' ';
    END;
    Schreib(St);
  END;

  S := 'Material:';
  FOR Y := -1 TO 1 DO
  IF Y <> 0 THEN
  BEGIN
    S := S + '   ';
    FOR X := B TO D DO
    BEGIN
      Z := (Material[Y] SHR (X SHL 2)) AND 15;
      FOR A := 1 TO Z DO
        IF y > 0 THEN S := S + upcase(englisch[X])
        ELSE S := S+englisch[x];
    END;
  END;
  Schreib(S); Schreib(' ');
END; END;

{----- I. Pflege von Brett und Angriffstabellen -----}

FUNCTION Bauer(PL: PLage; Position : Integer):Integer;

VAR Rang, Farbe, Richtung, P1, P2 : Integer;

BEGIN WITH PL^ DO BEGIN
  Farbe := Br[Position]; Result := 0;
  IF Farbe = 1 THEN Rang := Position AND 7 ELSE IF Farbe = -1 THEN Rang := (NOT Position) AND 7 ELSE Exit;
  IF Rang = 1 THEN BEGIN IF (Position >= 96) OR (Position < 32) THEN Result := 12 END
  ELSE
  BEGIN
    FOR Richtung := 1 DOWNTO -1 DO IF Richtung <> 0 THEN
    BEGIN
      P1 := Position+Richtung SHL 4;
      IF P1 AND 136 = 0 THEN
      BEGIN
        P2 := P1+Richtung SHL 4;
        IF Br[P1] = Farbe THEN Inc(Result, Rang SHL 2); {Phalanx}
        Dec(P1, Farbe);
        IF Br[P1] = Farbe THEN BEGIN Inc(Result, Rang); Inc(Result, Rang); Inc(Result, Rang) END {Custos}
        ELSE IF (Br[P1] <> -Farbe) AND ((P2 AND 136 <> 0) OR (Br[P2] <> -Farbe)) {Hilfe wird nicht gehemmt}
        THEN IF Rang > 2 THEN
        BEGIN
          Dec(P1, Farbe);
          IF (Br[P1] = Farbe) THEN Inc(Result, Rang) {Auxilium}
          ELSE BEGIN Dec(P1, Farbe); IF (Rang = 4) AND ((P2 AND 136 <> 0) OR (Br[P2-Farbe] <> -Farbe))
                     AND (Br[P1] = Farbe) THEN Inc(Result, Rang) END; {Auxilium ex initio}
        END;
      END;
    END;

    IF Result = 0 THEN Result := -10; {hilfloser Bauer}
    IF Rang > 4 THEN BEGIN Inc(Result, 32); IF Rang = 6 THEN Inc(Result, 64) END;
    Dec(Position, Farbe); IF Br[Position] = Farbe THEN Dec(Result, 12); {Epigonen}
    Dec(Position, Farbe); IF Br[Position] = Farbe THEN Dec(Result, 8)
  END;
  Dec(Result, 64); Result := Result*Farbe;
END END;

FUNCTION Rex(PL : PLage; Farbe:Integer): Integer;

VAR I, J, Position, Ausweichfeld, KP : Integer;

BEGIN WITH PL^ DO BEGIN
  KP := KPos[Farbe]; Ausweichfeld := 0; Result := 0; IF (KP < 16) OR (KP >= 112) THEN Inc(Result); {A- und H-Reihe vermeiden}
  FOR I := 7 DOWNTO 0 DO
  BEGIN
    Position := KP+KListe[I];
    IF Position AND 136 = 0 THEN
    BEGIN
      J := Zahl[Farbe AND 8+Position]; Inc(Result, J);
      IF (J = 0) AND (Br[Position]*Farbe <= 0) THEN Inc(Ausweichfeld);
    END;
  END;

  IF Result < 3 THEN Result := -Result SHL 3 ELSE Result := 64-Result SHL 5;
  Dec(Result, 32 SHR Ausweichfeld);

  Position := KP+Farbe;
  IF Position AND 136 = 0 THEN
  BEGIN {Bauernschild}
    J := 0;
    IF (Position >= 16) AND (Br[Position-16] = Farbe) THEN Inc(J, 6);
    IF (Position < 112) AND (Br[Position+16] = Farbe) THEN Inc(J, 6);
    IF Br[Position] = Farbe THEN BEGIN Inc(J, 6); J := J SHL 1 END; {Mittelbauer verbindet uere Bauern und strkt damit deren Wert}
    Inc(Result, J);
  END;
END END;

PROCEDURE Wirkung(PL : PLage; Figur, Farbe, Position : Integer; Setzen, Transparenz : Boolean);
{Pflegt die Angriffstabellen und die Beweglichkeitsbewertung
 durch Aktualisierung der Wirkung von Figur und Farbe auf X, Y auf die erreichbaren Felder.
 ist Setzen=1, werden die Angriffswerte gesetzt, sonst gelscht.

 Der Parameter "Transparenz" bestimmt, ob an der Durchlssigkeit des Felds fr "Bedrohungsstrahlen" etwas gendert werden mu:
 Ist "Transparenz" gesetzt und Setzen=1  (Figur wird auf leeres Feld gesetzt), werden Bedrohungsstrahlen auf das Feld gekrzt,
 ist "Transparenz" gesetzt und Setzen=-1 (Figur wird ersatzlos entnommen), werden sie ber das Feld hinaus verlngert}

VAR Beweg, I, Fig, Quell, Farb, dx, dy : Integer;
    Q : ^Bedroher;
    Z : ^DBrett;

  PROCEDURE Setze(Ziel : Integer);
  {Setzt/lscht eine Bedrohung ausgehend von (X, Y) auf das angegebene Feld und aktualisiert die Beweglichkeits-Bewertung}
  {$IFOPT O+}

  ASM
    MOV EDX, Z; ADD EDX, EAX                {EDX := @(Z^[Ziel]);}
    MOV ECX, EAX; SHL ECX, 3; ADD ECX, Q    {ECX := @(Q^[Ziel]);}
    MOVZX EAX, byte ptr [EDX]; ADD ECX, EAX {Inc(ECX, Z^[Ziel];}
    MOV AL, Byte(Quell)                     {AL := Quell;}
  CMP Setzen, 0; JZ @negativ
    MOV byte ptr [ECX], AL                  {Q^[Ziel, Z^[Ziel]] := Quell;}
    INC byte ptr [EDX]; INC Beweg; RET
  @negativ:
    DEC byte ptr [EDX]; DEC Beweg
    MOV AH, byte ptr [ECX-1]                {AH := Q^[Ziel, Z^[Ziel]];}
  @Finde: DEC ECX; CMP byte ptr [ECX], AL; JNE @Finde
    MOV byte ptr [ECX], AH
  END;
  {$ELSE}
  VAR Anzahl : ^ShortInt;
      Qz : ^BListe;
      J : Integer;

  BEGIN
    Anzahl := @(Z^[Ziel]); Qz := @(Q^[Ziel]);
    IF Setzen THEN
    BEGIN {Die Prfung, da der Angriff noch nicht gesetzt ist, entfllt, weil "sparsam genug" aufgerufen wird}
      Qz^[Anzahl^] := Quell; Inc(Anzahl^);
      Assert(Anzahl^ < 8); Inc(Beweg);
    END
    ELSE
    BEGIN
      FOR J := Anzahl^-1 DOWNTO 0 DO
      BEGIN
        Assert((J <> 0) OR (Qz^[J] = Quell));
        IF Qz^[J] = Quell THEN BEGIN Dec(Anzahl^); Qz^[J] := Qz^[Anzahl^]; Break END;
      END;
      Dec(Beweg)
    END;
  END; {$ENDIF}

  PROCEDURE Schiebe(Ziel, diff: Integer);
  {$IFOPT O+}

  ASM
    PUSH EBX; MOV EBX, EDX;
    @Anfang: ADD AL, BL; TEST AL, 136; JNZ @Ende
    PUSH EAX; CALL Setze; POP EAX
    MOV ECX, PL; CMP byte ptr [ECX+EAX+Lage.Br], 0; JZ @Anfang;
    @Ende: POP EBX
  {$ELSE}
  BEGIN
    REPEAT
      Inc(Ziel, diff); IF Ziel AND 136 <> 0 THEN Break;
      Setze(Ziel)
    UNTIL PL^.Br[Ziel] <> 0
  {$ENDIF}
  END;

  PROCEDURE TestSetze(Ziel: Integer);
  {$IFOPT O+}
  ASM ADD EAX, Quell; TEST AL, 136; JNZ @Ende; CALL Setze; @Ende: END;
  {$ELSE}
  BEGIN Inc(Ziel, Quell); IF Ziel AND 136 = 0 THEN Setze(Ziel) END;
  {$ENDIF}

BEGIN WITH PL^ DO BEGIN {Wirkung}
  IF Transparenz THEN {Durchlssigkeit des Position-Felds anpassen}
  BEGIN
    Setzen := NOT Setzen;
    FOR Farb := 1 DOWNTO -1 DO IF Farb <> 0 THEN
    BEGIN
      Q := @Ursprung[Succ(Farb) SHL 2]; Z := @Zahl[Succ(Farb) SHL 2];
      FOR I := Z^[Position]-1 DOWNTO 0 DO
      BEGIN
        Quell := Q^[Position, I]; {Quellinformationen auslesen}
        Fig := Farb*Br[Quell]; IF (Fig < L) OR (Fig > D) THEN Continue; {nur "strahlende" Figuren}
        dx := Position SHR 4-Quell SHR 4; dy := Position AND 7-Quell AND 7;
        IF dx > 0 THEN dx := 1 ELSE {$IFOPT O+} dx := dx SHR 4 {$ELSE} IF dx <> 0 THEN dx := -1 {$ENDIF};
        IF dy > 0 THEN dy := 1 ELSE {$IFOPT O+} dy := dy SHR 4 {$ELSE} IF dy <> 0 THEN dy := -1 {$ENDIF};
        Beweg := 0; Schiebe(Position, dx SHL 4+dy); {Durchlssigkeit anpassen}
        Inc(Bewertung, Farb*Beweg*MobWert[Fig])
      END;
    END;
    Setzen := NOT Setzen;
  END;

  {Wirkung der Strahlen AUS Position anpassen}
  Beweg := 0; Quell := Position; Q := @Ursprung[Succ(Farbe) SHL 2]; Z := @Zahl[Succ(Farbe) SHL 2];
  CASE Figur OF
    B : BEGIN TestSetze(Farbe-16); TestSetze(Farbe+16) END;
    S : FOR I := 7 DOWNTO 0 DO TestSetze(SListe[I]);
    K : FOR I := 7 DOWNTO 0 DO TestSetze(KListe[I]);
  ELSE
    IF Figur <> T THEN FOR I := 3 DOWNTO 0 DO Schiebe(Quell, KListe[I]);
    IF Figur <> L THEN FOR I := 7 DOWNTO 4 DO Schiebe(Quell, KListe[I]);
  END;

  Inc(Bewertung, Farbe*Beweg*MobWert[Figur]);
END END;

FUNCTION NeuMerkWert(PL : PLage; Z: Integer; anpassen: LongBool):Int64;
{ermittelt den Merkwert nach Ausfhrung des Zugs "Z".
"anpassen" steuert, ob zugleich EnPassant-, Rochade- und Bauernmaskenwerte angepat werden}

VAR Figur, Quell, Ziel, Zielfigur, Roch, A, Anz {$IFDEF Varianten}, Bauer, Position{$ENDIF} : Integer;
    {$IFDEF Varianten} BMaske : Int64;
    M, AltM : Integer; {$ENDIF}

BEGIN
  Roch := 0; Ziel := (Z SHR 8) AND $FF; Quell := Z AND $FF;
  Anz := Pl^.Anzug; A := Succ(Anz) SHL 2;
  Figur := Abs(Pl^.Br[Quell]);

  Result := Pl^.Merkwert;

  {$IFDEF Varianten}
  IF Crazyhouse THEN
  BEGIN
    Position := Quell AND 7+(Quell SHR 4) SHL 3;
    BMaske := Pl^.Bauernmaske; M := Pl^.Material[1] SHR 4; AltM := M;
    Result := Result XOR BMaske;
    IF (Z SHR 16 <> 0) AND (Quell = 0)
    THEN Bauer := Integer(Z SHR 16 = B)
    ELSE BEGIN
      Bauer := Integer(BMaske SHR Position) AND 1;
      BMaske := BMaske AND NOT (Int64(1) SHL Position);
    END;
    Position := Ziel AND 7+(Ziel SHR 4) SHL 3;
    BMaske := (BMaske AND NOT (Int64(1) SHL Position)) OR (Int64(Bauer) SHL Position);
  END;
  {$ENDIF}

  Result := Result XOR Zobrist[15]; {Anzugwechsel}
  {$IFDEF Varianten} IF (Z SHR 16 <> 0) AND (Quell = 0) THEN
  BEGIN
    IF anpassen THEN Dec(Pl^.Material[Anz], 1 SHL ((Z SHR 16) SHL 2));
    IF Anz = 1 THEN Dec(M, 1 SHL (Pred(Z SHR 16) SHL 2));
  END
  ELSE {$ENDIF} Result := Result XOR Zobrist[Pred(Figur) SHL 7+A+Quell]; {Quellfigur entnehmen}
  IF Z SHR 16 <> 0 THEN
  BEGIN
    Figur := Z SHR 16; {ggf. umwandeln}
    IF anpassen THEN
    {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF} Inc(Pl^.Material[Anz], 1 SHL (Figur SHL 2)-16)
  END;
  Result := Result XOR Zobrist[Pred(Figur) SHL 7+A+Ziel]; {am Ziel einsetzen, Anzug wechseln}

  IF Pl^.Br[Ziel] <> 0 {(klassisch) geschlagene Figur entnehmen}
  THEN BEGIN
    Zielfigur := Abs(Pl^.Br[Ziel]);
    IF Zielfigur = T THEN
    CASE Ziel OF 0 : Roch := 4; 7 : Roch := 1; 112 : Roch := 8; 119: Roch := 2 END;
    Result := Result XOR Zobrist[Pred(Zielfigur) SHL 7+A XOR 8+Ziel];
    {$IFDEF Varianten} IF Crazyhouse THEN
    BEGIN
      IF anpassen THEN
      BEGIN
        IF Odd(Pl^.Bauernmaske SHR Position) THEN Zielfigur := B;
        Inc(Pl^.Material[Anz], 1 SHL (Zielfigur SHL 2));
      END;
      IF Anz = 1 THEN Inc(M, 1 SHL (Pred(Zielfigur) SHL 2));
    END
    ELSE {$ENDIF} IF anpassen THEN Dec(Pl^.Material[-Anz], 1 SHL (Zielfigur SHL 2));
  END
  ELSE IF (Figur = B) AND (Ziel AND 112 <> Quell AND 112) {en passant geschlagenen Bauern entnehmen}
       {$IFDEF Varianten} AND (Zugtyp(Z).Erweiterung = 0) {$ENDIF}
       THEN BEGIN
         Result := Result XOR Zobrist[A XOR 8+Ziel AND 112+Quell AND 7];
         {$IFDEF Varianten}
         IF Crazyhouse THEN
         BEGIN
           BMaske := BMaske AND NOT (Int64(1) SHL (Quell AND 7+(Ziel SHR 4) SHL 3));
           IF anpassen THEN Inc(Pl^.Material[Anz], 16);
           IF Anz = 1 THEN Inc(M)
         END
         ELSE {$ENDIF} IF anpassen THEN Dec(Pl^.Material[-Anz], 16);
       END;

  IF Pl^.Enpassant AND 8 = 0 THEN
  BEGIN
    Result := Result XOR Zobrist[Pl^.EnPassant SHL 4];
    IF anpassen THEN Pl^.EnPassant := 8;
  END;

  CASE Figur OF
    B: IF ((Quell-Ziel) AND 1 = 0) {$IFDEF Varianten} AND (Zugtyp(Z).Erweiterung = 0) {$ENDIF} THEN
         IF ((Ziel >= 16) AND (Pl^.Br[Ziel-16] = -Anz)) {en-passant-Wert nur setzen, wenn Schlagzug mglich ist}
         OR ((Ziel < 112) AND (Pl^.Br[Ziel+16] = -Anz)) THEN
         BEGIN IF anpassen THEN Pl^.EnPassant := Ziel SHR 4; Result := Result XOR Zobrist[Ziel AND 112] END;
    T: IF (Quell-Anz) AND 8 <> 0
       THEN IF Quell < 16 THEN Roch := Roch OR (1 SHL Succ(Anz)) ELSE IF Quell >= 112 THEN Roch := Roch OR (2 SHL Succ(Anz));
    K: BEGIN
         Roch := Roch OR (3 SHL Succ(Anz));
         IF Quell-Ziel = 32 THEN {lang}
         BEGIN Result := Result XOR Zobrist[432+A+Ziel AND 7]; Result := Result XOR Zobrist[384+A+Ziel AND 7] END;
         IF Ziel-Quell = 32 THEN {kurz}
         BEGIN Result := Result XOR Zobrist[464+A+Ziel AND 7]; Result := Result XOR Zobrist[496+A+Ziel AND 7] END
       END
  END;

  Roch := Roch AND Pl^.Rochade;
  IF Roch <> 0 THEN
  BEGIN
    IF (Roch AND 1 <> 0) THEN BEGIN IF anpassen THEN Pl^.Rochade := Pl^.Rochade AND NOT 1; Result := Result XOR Zobrist[23] END;
    IF (Roch AND 2 <> 0) THEN BEGIN IF anpassen THEN Pl^.Rochade := Pl^.Rochade AND NOT 2; Result := Result XOR Zobrist[31] END;
    IF (Roch AND 4 <> 0) THEN BEGIN IF anpassen THEN Pl^.Rochade := Pl^.Rochade AND NOT 4; Result := Result XOR Zobrist[39] END;
    IF (Roch AND 8 <> 0) THEN BEGIN IF anpassen THEN Pl^.Rochade := Pl^.Rochade AND NOT 8; Result := Result XOR Zobrist[47] END
  END;
  {$IFDEF Varianten} IF Crazyhouse THEN
  BEGIN
    Result := Result XOR BMaske;
    M := M XOR AltM; FOR Bauer := 17 DOWNTO 0 DO IF Odd(M SHR Bauer) THEN Result := Result XOR Zobrist[768+Bauer];
    IF anpassen THEN Pl^.Bauernmaske := BMaske;
  END; {$ENDIF}
END;

PROCEDURE Ziehe(Ebene, Z:Integer);
{Setzt den Zug um, aktualisiert dabei
  - Angriffs- und Beweglichkeitstabellen,
  - Stillstand, Bewertung
  - Rochademglichkeiten, EnPassant, Merkwert (ausgelagert in "NeuMerkwert")
 ACHTUNG: Nach dem Zug mu geprft werden, ob der Knig im Schach steht,
 da der Zugerzeuger das mangels aktueller Angriffstabellen noch nicht abfngt!}

VAR Figur, BMin, BMax, ZX, ZY, QX, QY, Quell, Ziel, geschlagen, dran : Integer;
    PL : PLage;

BEGIN
  PL := @(Analyse[Ebene+1]); PL^ := Analyse[Ebene];
  BMax := 0; BMin := 8;
  Quell := Zugtyp(Z).Quelle; QX := Quell SHR 4; QY := Quell AND 7;
  Ziel  := Zugtyp(Z).Ziel;   ZX := Ziel  SHR 4; ZY := Ziel  AND 7;
  WITH PL^ DO
  BEGIN
    Merkwert := NeuMerkwert(PL, Z, true);
    Inc(Stillstand); dran := Anzug; Figur := -Br[Ziel]*dran;
    geschlagen := Figur;
    IF geschlagen <> 0 THEN
    BEGIN
      Inc(Bewertung, MatWert[Figur]*dran); {Material vernichten}
      {$IFDEF Varianten} IF Crazyhouse THEN
      BEGIN
        IF Odd(Analyse[Ebene].Bauernmaske SHR (ZY+ZX SHL 3))
        THEN
        BEGIN
          Inc(Bewertung, (-32+MatWert[B]+Handwert[B] SHR ((Analyse[Ebene].Material[dran] SHR 4) AND 7))*dran);
          IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX
        END
        ELSE Inc(Bewertung, (32+MatWert[Figur]+Handwert[Figur] SHR ((Analyse[Ebene].Material[dran] SHR (Figur SHL 2)) AND 7))*dran);
      END; {$ENDIF}
      Wirkung(PL, Figur, -dran, Ziel, false, false); {Angriffswirkung der geschlagenen Figur entfernen}
      {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF} BEGIN Stillstand := 0; Dec(Fortschritt); END;
      IF Figur = B THEN
      BEGIN
        IF dran > 0 THEN Dec(Fortschritt, ZY) ELSE Dec(Fortschritt, 7-ZY);
        IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX
      END
    END
    ELSE IF (Br[Quell] = dran) AND (ZX <> QX) {$IFDEF Varianten} AND (Zugtyp(Z).Erweiterung = 0) {$ENDIF}
    THEN {en passant => gegnerischer Bauer mu entnommen werden}
    BEGIN
      IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX;
      Inc(Bewertung, MatWert[B]*dran); {Bauernmaterial vernichten}
      {$IFDEF Varianten} IF Crazyhouse THEN
        Inc(Bewertung, (-32+MatWert[B]+Handwert[B] SHR ((Analyse[Ebene].Material[dran] SHR 4) AND 7))*dran); {$ENDIF}
      Wirkung(PL, B, -dran, Ziel AND 112+QY, false, true); {Angriffs- und Transparenzwirkung des geschlagenen Bauern beseitigen}
      Br[Ziel AND 112+QY] := 0; {geschlagenen Bauern vom Brett nehmen}
      IF dran > 0 THEN Dec(Fortschritt, QY+1) ELSE Dec(Fortschritt, 8-QY);
    END;

    {$IFDEF Varianten} IF (Quell <> 0) OR (Zugtyp(Z).Erweiterung = 0) THEN
    BEGIN {$ENDIF}
      Figur := Br[Quell]*dran; Br[Quell] := 0; {Quelle entfernen}
      Wirkung(PL, Figur, dran, Quell, false, true);
      IF Figur = B THEN
      BEGIN
        IF BMin > QX THEN BMin := QX; IF BMax < QX THEN BMax := QX;
        {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF}
        BEGIN Stillstand := 0; Dec(Fortschritt, (ZY-QY)*dran) END;
        IF Z SHR 16 <> 0 THEN
        BEGIN
          Figur := Z SHR 16;
          Inc(Bewertung, (MatWert[Figur]-MatWert[B])*dran);
        END;
      END;
    {$IFDEF Varianten} END ELSE
    BEGIN
      Figur := Z SHR 16;
      Dec(Bewertung, (32+(Handwert[Figur] SHR ((Material[dran] SHR (Figur SHL 2)) AND 7)))*dran);
      IF Figur = B THEN BEGIN Inc(Bewertung, 64*dran); IF BMin > ZX THEN BMin := ZX; IF BMax < ZX THEN BMax := ZX END
    END; {$ENDIF}
    IF Figur = K THEN
    BEGIN
      KPos[dran] := Ziel; {Umzug notiert}

      IF Quell-Ziel = 32 THEN {lange Rochade}
      BEGIN {Turmumstellung}
        Wirkung(PL, T, dran, ZY, false, false); {Turm entfernen; in der Ecke kein Transparenzproblem}
        Wirkung(PL, T, dran, 3 SHL 4+ZY, true, true); {Turm wieder einsetzen}
        Br[3 SHL 4+ZY] := Br[ZY]; Br[ZY] := 0;
      END;
      IF Ziel-Quell = 32 THEN {kurze Rochade}
      BEGIN {Turmumstellung}
        Wirkung(PL, T, dran, 7 SHL 4+ZY, false, false); {Turm entfernen; in der Ecke kein Transparenzproblem}
        Wirkung(PL, T, dran, 5 SHL 4+ZY, true, true); {Turm wieder einsetzen}
        Br[5 SHL 4+ZY] := Br[7 SHL 4+ZY]; Br[7 SHL 4+ZY] := 0;
      END
    END;

    Br[Ziel] := Figur*dran; {Ziel (er)setzen}
    Wirkung(PL, Figur, dran, Ziel, true, geschlagen = 0); {neue Zielwirkung}

    Anzug := -dran; IF dran < 0 THEN Inc(Zugnummer); {fertig gezogen, Farbe wechselt}

    FOR QX := BMin-2 TO BMax+2 DO IF QX AND 8 = 0 THEN
      FOR QY := 1 TO 6 DO
      BEGIN
        geschlagen := QX SHL 4+QY+8;
        Dec(Bewertung, Br[geschlagen]);
        Br[geschlagen] := Bauer(PL, geschlagen-8);
        Inc(Bewertung, Br[geschlagen])
      END;
    Chronik[Zugnummer SHL 1+Succ(dran) SHR 1] := Merkwert;
  END;
END;

PROCEDURE FEN(CONST Zeile:String);

VAR Figur, I, Farbe, Position : Integer;
    PL : PLage;
    {$IFDEF Lernen} F : FILE; {$ENDIF}

BEGIN
  PL := @(Analyse[0]); FillChar(PL^, SizeOf(Lage), #0);
  I := 1; Position := 7;
  WITH PL^ DO
  BEGIN
    WHILE Zeile[I] <> ' ' DO {erste Gruppe}
    BEGIN
      IF Zeile[I] = '/' THEN {$IFDEF Varianten} IF Position AND 7 = 0 THEN Position := -32768 ELSE {$ENDIF} Position := Pred(Position) AND 7
      ELSE IF Zeile[I] < #64 THEN Inc(Position, (Ord(Zeile[I])-48) SHL 4)
      ELSE
      BEGIN
        IF Zeile[I] >= #96 THEN Farbe := -1 ELSE Farbe := 1;
        Figur := Pos(Char(Byte(Zeile[I]) OR 32), englisch); IF Figur = K THEN KPos[Farbe] := Position
        ELSE {$IFDEF Varianten} IF (NOT Crazyhouse) OR (Position < 0) THEN BEGIN {$ENDIF} Inc(Material[Farbe], 1 SHL (Figur SHL 2));
        {$IFDEF Varianten} Inc(I); Continue END; {$ENDIF}
        Br[Position] := Farbe*Figur; Inc(Bewertung, Farbe*MatWert[Figur]);
        Wirkung(PL, Figur, Farbe, Position, true, true); {Angriffstabelle mitaufbauen}
        Merkwert := Merkwert XOR Zobrist[Pred(Figur) SHL 7+Succ(Farbe) SHL 2+Position];
        Inc(Fortschritt); IF Figur = B THEN IF Farbe > 0 THEN Inc(Fortschritt, (NOT Position) AND 7) ELSE Inc(Fortschritt, Position AND 7);
        {$IFDEF Varianten}
        IF (Zeile[I+1] = '~') OR (Figur = B) THEN
        BEGIN
          Bauernmaske := Bauernmaske OR ((Int64(1) SHL (Position AND 7+(Position SHR 4) SHL 3)));
          IF Zeile[I+1] = '~' THEN Inc(I);
        END;
        {$ENDIF}
        Inc(Position, 16)
      END;
      Inc(I)
    END;

    IF Zeile[I+1] = 'b' THEN BEGIN Anzug := -1; Merkwert := Merkwert XOR Zobrist[15] END ELSE Anzug := 1;
    Inc(I, 3); {2. Gruppe: Anzug}

    WHILE Zeile[I] <> ' ' DO {3. Gruppe: Rochaderechte}
    BEGIN
      CASE Zeile[I] OF
        'q' : BEGIN Rochade := Rochade OR 1; Merkwert := Merkwert XOR Zobrist[23] END;
        'k' : BEGIN Rochade := Rochade OR 2; Merkwert := Merkwert XOR Zobrist[31] END;
        'Q' : BEGIN Rochade := Rochade OR 4; Merkwert := Merkwert XOR Zobrist[39] END;
        'K' : BEGIN Rochade := Rochade OR 8; Merkwert := Merkwert XOR Zobrist[47] END;
      END;
      Inc(I)
    END;
    Inc(I); {4. Gruppe: En Passant}
    IF Zeile[I] = '-' THEN EnPassant := 8 ELSE
    BEGIN EnPassant := Ord(Zeile[I])-97; Merkwert := Merkwert XOR Zobrist[EnPassant SHL 4]; Inc(I) END;

    Inc(I, 2); Stillstand := Ord(Zeile[I])-48; {5. Gruppe: Stillstand}
    Inc(I); IF Zeile[I] <> ' ' THEN BEGIN Stillstand := Stillstand*10+Ord(Zeile[I])-48; Inc(I) END;
    Inc(I);

    Zugnummer := StrToInt(Copy(Zeile, I, 32767)); {genaugenommen mte nun noch die Chronik ergnzt werden}
    FOR I := 127 DOWNTO 0 DO IF I AND 8 <> 0 THEN BEGIN Br[I] := Bauer(PL, I-8); Inc(Bewertung, Br[I]) END;
    {$IFDEF Lernen}
    Name := IntToStr(Integer(Merkwert));
    {$IFDEF Varianten} IF Crazyhouse THEN Name := Name + 'zh'; {$ENDIF}
    Name := Name + '.lrn';
    AssignFile(F, Name);
    IF (Zugnummer = 1) AND (Status = 0) THEN
    BEGIN
      Inc(Status);
      {$I-} ReSet(F, 1); {$I+}
      IF IOResult = 0 THEN
      BEGIN
        BlockRead(F, Hirn[0], FileSize(F));
        gemerkt := 0; FOR I := Hirnmaske DOWNTO 0 DO IF Hirn[i].MW <> 0 THEN Inc(gemerkt);
        CloseFile(F);
      END;
    END;
    {$ENDIF}
  END;
END;

{----- II. Suche -----}

FUNCTION ZugName(Z: Integer):String;

BEGIN
  SetLength(Result, 5); Result[1] := #32;
  Result[3] := Chr(Z AND 7); Z := Z SHR 4; Result[2] := Chr(Z AND 7); Z := Z SHR 4;
  Result[5] := Chr(Z AND 7); Z := Z SHR 4; Result[4] := Chr(Z AND 7); Z := Z SHR 4;
  IF Z <> 0 THEN
  {$IFDEF Varianten} IF Result[3] = #0 THEN Result[3] := #15 ELSE {$ENDIF} Result := Result+englisch[Z];
  Inc(PInteger(@(Result[2]))^, 828453217);
  {$IFDEF Varianten} IF Result[3] = '@' THEN Result[2] := UpCase(englisch[Z]); {$ENDIF}
END;

FUNCTION PV(Zug: Integer):String;

VAR Ebene, I : Integer;

BEGIN
  Result := '';
  FOR Ebene := 0 TO 32 DO IF Zug <> 0 THEN
  BEGIN
    Result := Result+ZugName(Zug); Ziehe(Ebene, Zug);
    FOR I := 0 TO Ebene-1 DO IF Analyse[I].Merkwert = Analyse[Ebene+1].Merkwert THEN Exit;
    Zug := 0;
    WITH Analyse[Ebene+1], Hirn[Integer(Merkwert) AND Hirnmaske] DO
      IF MW = Merkwert THEN Zug := BestZug AND $FFFFFF;
  END;
END;

FUNCTION Statistik(Tiefe: Integer) : String;

BEGIN
  Result := ' depth '+IntToStr(Tiefe)+' seldepth '+IntToStr(selektiv)+' nodes '+IntToStr(Knoten)
   +' nps '+IntToStr(Knoten DIV Succ(vergangen DIV 1000))+' hashfull '+IntToStr(gemerkt DIV (Hirnmaske DIV 1000))
END;

FUNCTION Wertung(Wert: Integer):String;

BEGIN
  IF Wert > 16384 THEN Result := 'mate '+IntToStr((30002-Wert) SHR 1)
  ELSE IF Wert < -16384 THEN Result := 'mate '+IntToStr(-((30001+Wert) SHR 1))
  ELSE Result := 'cp '+IntToStr(Wert);
END;

FUNCTION Suche(Ebene, Tiefe, alpha, beta, erweitert : Integer; VAR Z: Integer; favorisiert : boolean; Soll: Integer): Integer;
{Wir suchen nur Zge, deren Wert ECHT grer als alpha ist; er ist gut genug, wenn er MINDESTENS den Wert beta hat.
 Man kann also nur dann davon ausgehen, da der Wert exakt ist, wenn er im INNERN des Intervalls liegt.}

LABEL blockiert, illegal, nichtSuchen, fertig, aufschieben;

VAR Zugwahl : ARRAY[{$IFDEF Varianten}0..511{$ELSE}Byte{$ENDIF}] OF ZugwahlR;
    dran, Vergleich, Anfang, I, MinWert, MaxWert, Zugzahl, jetztZug, unserFavorit, Schach, J, Kp : Integer;
    X, Y, Bauernrang, Zielfigur, Figur, Ziel, Veteran, X1, X2, Vorurteil : Integer;
    NeuMW : Int64;
    Deckung, Gegner : ^DBrett;

  PROCEDURE Merke(W, T, NeuEbene: Integer);
  {Speichert eine Information ber die Bewertung der Stellung vor (NeuEbene=0) oder nach (NeuEbene=1) dem "jetztZug"
   diese ist eher grer als W, wenn T = 1, eher kleiner, wenn T = -1, und gleich W, wenn T = 0.}

  VAR MerkTiefe : Integer;

  BEGIN WITH Analyse[Ebene+NeuEbene], Hirn[Integer(MerkWert) AND Hirnmaske] DO BEGIN
    Merktiefe := Tiefe-erweitert; IF Merktiefe <> 0 THEN Dec(Merktiefe, NeuEbene);
    IF (Merktiefe < tief) AND ({$IFDEF Varianten} Crazyhouse OR {$ENDIF} (Zugtyp(BestZug).Fortschritt <= Analyse[0].Fortschritt)) THEN Exit;
    tief := Merktiefe; IF MW <> Merkwert THEN BEGIN IF MW = 0 THEN Inc(gemerkt); MW := Merkwert; BestZug := 0; END;
    IF (NeuEbene = 0) AND (Z <> 0) THEN BestZug := Z;
    Wert := W; Typ := T;
    Zugtyp(Bestzug).Fortschritt := Fortschritt;
  END END;

  PROCEDURE Notiere(Wert: Integer);
  {verarbeitet die Information, da jetztZug mindestens den Wert "Wert" hat}

  LABEL Ausgabe;

  BEGIN
   {$IFDEF Zwei}
    IF (Zwei <> 0) AND (Ebene = 0) AND (Z <> 0) AND ((Wert > ZWert) OR (Zweitzug = 0)) AND (jetztZug <> Z) THEN
        IF Wert > Result
        THEN BEGIN Zweitzug := Z; ZWert := Result END
        ELSE BEGIN Zweitzug := jetztZug; ZWert := Wert END;
    {$ENDIF}

    IF (Wert > Result) THEN
    BEGIN
      Z := jetztZug; Result := Wert;
      IF (Wert >= beta) AND (Wert > -16384) THEN Merke(-Result, -1, 0);
      IF (Ebene = 0) AND (Zustand AND Hauptzugdurch <> 0) THEN
      BEGIN
        HWert := Wert;
Ausgabe: IF Z <> HauptZug THEN BEGIN Neuerung := Tiefe; HauptZug := Z END;
        {$IFDEF Varianten}
        IF (Protokoll = PWinboard) AND (Winboard AND WAusgabe <> 0)
        THEN Schreib(IntToStr(Tiefe)+' '+IntToStr(Wert)+' '+IntToStr(vergangen DIV 10)+' '+IntToStr(Knoten)+' '+PV(Z))
        ELSE IF Protokoll = PUCI THEN {$ENDIF}
        Schreib('info score '+Wertung(Wert)+Statistik(Tiefe)+' pv'+PV(Z));
        Selektiv := 0; Richtwert := Grundwert;
        IF (Succ(Tiefe) < Letzttiefe) OR (Abs(Letztwert-HWert+8) > 24) THEN Richtwert := Richtwert+Richtwert; {Tiefenmangel / quantitative berraschungen verarbeiten}
        IF LetztWert-HWert > 64 THEN Richtwert := Richtwert+Richtwert; {... besonders bei Katastrophen}
        IF (HWert-ZWert > 16) THEN Richtwert := Richtwert+(Richtwert SHL 2) SHR (Tiefe-Neuerung); {qualitative berraschungen verarbeiten}
        IF HWert = 0 THEN Richtwert := Richtwert SHL 1; {bei Verdacht auf Unentschieden tiefer suchen}
        J := Analyse[0].Stillstand; IF (J > 20) AND (J < 90) AND (LetztWert-HWert < 16) THEN Richtwert := Richtwert SHR 1; {vermutlich ereignisarme Passagen schneller spielen}
      END;
    END
    ELSE IF (Ebene = 0) AND (jetztZug = HauptZug) THEN BEGIN HWert := Result; Hauptzug := Z; GOTO Ausgabe END; {Nachnominierung}
  END;

BEGIN
  IF Tiefe = 0 THEN Result := alpha ELSE
  BEGIN
    Result := -32000;
    IF (Tiefe > 1) AND (alpha < 16384) AND (beta > -16384) THEN {wenn Vorkenntnisse fehlen, erst einmal flacher suchen}
      WITH Analyse[Ebene], Hirn[Integer(Merkwert) AND Hirnmaske] DO
      IF MW <> Merkwert THEN Suche(Ebene, Pred(Tiefe)-Integer(Tiefe > 2), alpha, beta, erweitert, Z, favorisiert, -16384);
  END;

  unserFavorit := Z; Z := 0;
  IF Selektiv < Ebene THEN Selektiv := Ebene;
  WITH Analyse[Ebene] DO
  BEGIN
    Deckung := @Zahl; Gegner := @Zahl;
    dran := Anzug; IF dran > 0 THEN Inc(Integer(Deckung), 8) ELSE Inc(Integer(Gegner), 8);
    kp := kpos[dran]; Schach := Gegner^[kp];
    Zugzahl := 0;  {--- III.A Zuggenerator ---}
    {Erzeugt eine Liste der Pseudo-Zge: erkennt illegale Knigszge, aber prft nicht, ob eine gespiete Figur unzulssig bewegt wird}
    FOR X := 0 TO 7 DO
      FOR Y := 0 TO 7 DO
      BEGIN
        Ziel := X SHL 4+Y;
        Figur := Br[Ziel]*dran;
        IF Figur <= 0 THEN
        BEGIN {erzeuge Schlagzge mit dem Ziel "Ziel"}
          IF Figur OR Tiefe = 0 THEN Continue; {in Ruhesuche nur Schlagzge}
          Zielfigur := -Figur;
          FOR I := Deckung^[Ziel]-1 DOWNTO 0 DO
          BEGIN
            Anfang := Ursprung[Succ(dran) SHL 2+Ziel, I];
            Figur := Br[Anfang]*dran;
            IF ((Figur <> B) OR ((Zielfigur <> 0) AND (Y <> 0) AND (Y <> 7))) AND {Bauern-Spezialzge werden nicht hier, sondern unten erzeugt}
               ((Figur <> K) OR (Gegner^[Ziel] = 0)) THEN {Knig darf sich nicht in Schach begeben}
            BEGIN
              IF (Tiefe = 0) AND (Matwert[Zielfigur] < Soll) THEN Continue;
              IF (Gegner^[Ziel] <> 0) AND (Tiefe = 0) AND (MatWert[Zielfigur] <= MatWert[Figur]) THEN {GEBOTEN: Wirkung auf Quellfeld bercksichtigen!}
              BEGIN {GEBOTEN: prfen, ob alle Gegner Knigsbindung haben}
                IF Deckung^[Ziel] <= 1 THEN Continue; {GEBOTEN: prfen, ob wir noch alte Drohungen umsetzen knnen}
                {$IFDEF Varianten} IF Crazyhouse THEN Continue; {$ENDIF}
              END;
              Zugwahl[Zugzahl].Zugwort := Ziel SHL 8+Anfang; Inc(Zugzahl);
            END;
          END;
          {$IFDEF Varianten}
          IF Crazyhouse AND (Zielfigur = 0) AND (((Schach = 0) AND ((Gegner^[Ziel] = 0) OR (Deckung^[Ziel] <> 0))) OR ((Schach = 1) AND (Gegner^[Ziel] <> 0))) THEN
            FOR Zielfigur := B TO D DO
              IF (((Material[dran] SHR (Zielfigur SHL 2)) AND 15) <> 0)
              AND ((Zielfigur <> B) OR ((Y <> 0) AND (Y <> 7))) THEN
              BEGIN Zugwahl[Zugzahl].Zugwort := Ziel SHL 8+Zielfigur SHL 16; Inc(Zugzahl) END;
          {$ENDIF}
        END
        ELSE {erzeuge Spezialzge mit der Quelle "Ziel"}
        BEGIN
          IF Figur = B THEN
          BEGIN
            Anfang := Ziel; Inc(Ziel, dran); Bauernrang := (Anfang XOR (dran SHR 1)) AND 7;
            IF Bauernrang < 6 THEN
            BEGIN
              IF Bauernrang = 4 THEN {en passant}
              BEGIN
                IF (EnPassant=X-1) AND (Br[Ziel-16] = 0) THEN
                BEGIN Zugwahl[Zugzahl].Zugwort := Anfang+Ziel SHL 8-4096; Inc(Zugzahl) END;
                IF (X <> 7) AND (EnPassant=X+1) AND (Br[Ziel+16] = 0) THEN
                BEGIN Zugwahl[Zugzahl].Zugwort := Anfang+Ziel SHL 8+4096; Inc(Zugzahl) END;
              END;
              IF (Br[Ziel] = 0) AND (Tiefe <> 0) THEN
              BEGIN {gerade Bauernzge}
                Zugwahl[Zugzahl].Zugwort := Anfang+Ziel SHL 8; Inc(Zugzahl);
                Inc(Ziel, dran);
                IF (Bauernrang = 1) AND (Br[Ziel] = 0) THEN
                BEGIN Zugwahl[Zugzahl].Zugwort := Anfang+Ziel SHL 8; Inc(Zugzahl) END
              END
            END
            ELSE
            BEGIN
              FOR I := D DOWNTO S DO {Bauernumwandlung}
              BEGIN
                Zielfigur := Anfang+Ziel SHL 8+I SHL 16;
                IF Br[Ziel] = 0 THEN BEGIN Zugwahl[Zugzahl].Zugwort := Zielfigur; Inc(Zugzahl) END;
                IF (X <> 0) AND (Br[Ziel-16]*dran < 0) THEN BEGIN Zugwahl[Zugzahl].Zugwort := Zielfigur-4096; Inc(Zugzahl) END;
                IF (X <> 7) AND (Br[Ziel+16]*dran < 0) THEN BEGIN Zugwahl[Zugzahl].Zugwort := Zielfigur+4096; Inc(Zugzahl) END;
                IF Tiefe = 0 THEN Break
              END
            END
          END
          ELSE IF (Figur = K) AND (Tiefe <> 0) AND (Gegner^[Y+64] = 0) THEN {Rochade}
          BEGIN
            Bauernrang := Rochade SHR Succ(dran);
            IF (Bauernrang AND 1 <> 0) AND (Br[Y+16] = 0) AND (Br[Y+32] = 0) AND (Br[Y+48] = 0)
            AND (Gegner^[Y+32] = 0) AND (Gegner^[Y+48] = 0) THEN
            BEGIN Zugwahl[Zugzahl].Zugwort := Y SHL 8+Y+8256; Inc(Zugzahl) END;
            IF (Bauernrang AND 2 <> 0) AND (Br[Y+80] = 0) AND (Br[Y+96] = 0)
            AND (Gegner^[Y+80] = 0) AND (Gegner^[Y+96] = 0) THEN
            BEGIN Zugwahl[Zugzahl].Zugwort := Y SHL 8+Y+24640; Inc(Zugzahl) END
          END;
        END;
    END;

    {--- III.B Vorsortierung ---}
    Anfang := 0; I := ZugZahl-1; IF Zugzahl > 0 THEN Inc(Knoten);
    WHILE I >= Anfang DO
    BEGIN
      jetztZug := Zugwahl[I].Zugwort;
      NeuMW := NeuMerkWert(@(Analyse[Ebene]), jetztZug, false);
      FOR Vergleich := Stillstand DOWNTO 2 DO {IF Odd(Vergleich) THEN}
      IF NeuMW = Chronik[Zugnummer SHL 1+(dran AND 2) SHR 1-Vergleich] THEN
      BEGIN {Zugwiederholung}
        IF (Ebene = 0) AND (jetztZug = HauptZug) THEN Zustand := Zustand OR HauptzugDurch;
        Notiere(0); IF beta <= 0 THEN Exit;
        Zugwahl[I] := Zugwahl[Anfang]; Inc(Anfang); GOTO fertig; {Zug mu nicht weiter betrachtet werden}
      END;

      Vergleich := -16384; {- III.B.1 materieller Schtzwert -}
      Ziel := (jetztZug SHR 8) AND $FF; MaxWert := Gegner^[Ziel];
      Inc(Vergleich, MatWert[Abs(Br[Ziel])]); {Schlagzug vergten}
      Inc(Vergleich, MatWert[jetztZug SHR 16]); {Umwandlung vergten}
      MinWert := MatWert[Abs(Br[jetztZug AND $FF])];
      {$IFDEF Varianten} IF Crazyhouse AND (jetztZug SHR 16 <> 0) AND (jetztZug AND $FF = 0) THEN Dec(Vergleich, 1024); {$ENDIF}
      IF (Gegner^[jetztZug AND $FF] <> 0) THEN Inc(Vergleich, MinWert SHR 5); {Ausweichen gering belohnen}
      IF Maxwert <> 0 THEN Dec(Vergleich, Minwert SHR 1); {deutlich von neuen Risiken abraten}

      IF (Schach <> 0) AND (EnPassant AND 8 <> 0) THEN {- III.B.2 Ausdnnen von Antworten auf Schachgebote -}
      BEGIN
        IF Byte(kp) <> Zugtyp(jetztZug).Quelle THEN {ohne auszuweichen ...}
        IF Schach <> 1 THEN GOTO illegal {... knnen wir keinem Doppelschach entgehen}
        ELSE BEGIN
          MinWert := Ursprung[dran AND 8+kp, 0]; {Einzelbedroher ...}
          IF Ziel = MinWert THEN Inc(Vergleich, 1024) {... bevorzugt schlagen}
          ELSE
          BEGIN {... notfalls blockieren}
            IF Abs(Br[MinWert]) <> S THEN
            FOR J := Maxwert-1 DOWNTO 0 DO
              IF (Ursprung[dran AND 8+Ziel, J] = MinWert)
              AND ((kp AND   7-Ziel AND   7)*(Ziel AND   7-MinWert AND   7) >= 0)
              AND ((kp AND 112-Ziel AND 112)*(Ziel AND 112-MinWert AND 112) >= 0)
              THEN GOTO blockiert;
            illegal: Dec(Zugzahl); Zugwahl[I] := Zugwahl[Zugzahl]; Dec(I); Continue
          END;
        END;
      END; blockiert:

      WITH Hirn[Integer(NeuMW) AND Hirnmaske] DO IF NeuMW = MW THEN {- III.B.3 Nutzen von Erinnerungen -}
      BEGIN
        MinWert := Wert; Dec(MinWert, MinWert DIV 16384); {Mattabstand anpassen}
        IF (Succ(tief) >= Tiefe) OR ((Typ >= 0) AND (MinWert > 16384)) THEN
        BEGIN
          IF Typ >= 0 THEN BEGIN Notiere(MinWert); IF Result >= beta THEN Exit END;
          IF (Typ <= 0) AND (((MinWert <= Result) AND ((Ebene <> 0) OR (MinWert <= ZWert))) OR (MinWert <= alpha)) THEN
          BEGIN
            Zugwahl[I] := Zugwahl[Anfang]; Inc(Anfang);
            IF (MinWert > Result) AND (MinWert <= alpha) THEN Result := MinWert; Continue
          END;
        END;
        IF Typ >= 0 THEN Vergleich := MinWert;
      END;

      IF jetztZug = unserFavorit THEN Zugwahl[I].Sortierung := 32767 ELSE Zugwahl[I].Sortierung := Vergleich;
      Dec(I); fertig:
    END
  END;

  IF (Wahl AND Nullzug <> 0) AND (Tiefe > 1) AND (beta < 16384) AND (Schach = 0) AND (Zugzahl > 12) AND (Soll <> 12345) THEN
  BEGIN
    {Vergleich := -32000; Y := unserFavorit; J := Pred(Tiefe); IF NOT favorisiert THEN Dec(J);
    IF (J > 0) THEN Vergleich := Suche(Ebene, J, beta-1, beta, erweitert, Y, favorisiert, 12345);
    IF Vergleich >= beta THEN}
    BEGIN
     {X1 := Analyse[Ebene].Material[dran] SHR 8; X2 := 0; WHILE X1 <> 0 DO BEGIN Inc(X2, X1 AND 15); X1 := X1 SHR 4 END;

     IF X2 > 2 THEN}
     BEGIN
       Analyse[Ebene+1] := Analyse[Ebene]; WITH Analyse[Ebene+1] DO
       BEGIN Anzug := -dran; Merkwert := Analyse[Ebene].Merkwert XOR Zobrist[15]; Stillstand := 0; EnPassant := 8 END;
       Y := 0; J := Tiefe-3; IF J <= 0 THEN J := 1;
       Vergleich := -Suche(Ebene+1, J, -beta, Succ(-beta), 0, Y, false, 12345);
       IF Vergleich >= beta THEN BEGIN IF Vergleich < 16384 THEN Result := Vergleich ELSE Result := beta; Exit END;
     END;
    END;
  END;

  {--- III.C Eigentliche Suche ---}
  WHILE Anfang < Zugzahl DO
  BEGIN
    {Zug mit bester Voreinschtzung nach vorn}
    Vergleich := -32768; Maxwert := 0;
    FOR I := Zugzahl-1 DOWNTO Anfang DO
      IF Vergleich < Zugwahl[I].Sortierung THEN BEGIN Vergleich := Zugwahl[I].Sortierung; MaxWert := I; END;
    WITH Zugwahl[MaxWert] DO BEGIN jetztZug := Zugwort; Vorurteil := Sortierung END;
    Zugwahl[MaxWert] := Zugwahl[Anfang];
    Ziehe(Ebene, jetztZug);

    WITH Analyse[Ebene+1] DO
    IF (Zahl[dran AND 8+KPos[dran]] <> 0) {illegal?}
    THEN BEGIN Dec(Zugzahl); Zugwahl[Anfang] := Zugwahl[Zugzahl]; Continue END
    ELSE IF {$IFDEF Varianten} (NOT Crazyhouse) AND {$ENDIF} (Stillstand = 100) THEN Vergleich := 0 {50-Zge-Regel}
    ELSE BEGIN
      IF {$IFDEF Varianten} (Protokoll = PUCI) AND {$ENDIF} (Ebene = 0) AND (Knoten > 65536) THEN Schreib('info currmove'+ZugName(jetztZug)+' currmovenumber '+IntToStr(Succ(Anfang))+Statistik(Tiefe));

      {- Planung von Erweiterungen -}
      MinWert := -beta;
      Veteran := 0; IF favorisiert AND (jetztZug = unserFavorit) THEN
      BEGIN
        Veteran := 1;
        IF (Ebene <> 0) AND (Analyse[Ebene].Br[Zugtyp(jetztZug).Ziel] <> Analyse[Ebene-1].Br[Zugtyp(jetztZug).Ziel]) {Reflexzug}
        THEN BEGIN
          Ziel := MatWert[Abs(Analyse[Ebene].Br[Zugtyp(jetztZug).Ziel])]; {Gewinn}
          IF Gegner^[Zugtyp(jetztZug).Ziel] <> 0 THEN Dec(Ziel, MatWert[Abs(Br[Zugtyp(jetztZug).Ziel])]);
          IF (Ebene > 0) AND (Analyse[Ebene-1].Br[Zugtyp(jetztZug).Ziel]*dran > 0)
          THEN Dec(Ziel, MatWert[Abs(Analyse[Ebene-1].Br[Zugtyp(jetztZug).Ziel])]);
          IF Ziel > 0 THEN Veteran := 2;
        END;
      END;

      X := 0; I := Tiefe; IF I <> 0 THEN Dec(I);
      {$IFDEF Varianten} IF (NOT Crazyhouse) OR (Ebene < 24) THEN {$ENDIF}
      IF (((Wahl AND ESchach <> 0) OR (I = 0)) AND (Zahl[Succ(dran) SHL 2+KPos[-dran]] <> 0)) {Schacherweiterung}
      OR ((Wahl AND EZwang <> 0) AND (Tiefe <> 0) AND ((Zugzahl = 1) OR
            (((Wahl AND EDruck <> 0) {$IFDEF Varianten} OR (Crazyhouse AND favorisiert) {$ENDIF}) AND (Result < -16384) AND (beta > -16384) AND (Anfang + 1 = Zugzahl)))) {Zwang}
      OR ((Wahl AND EOpfer <> 0) AND ((Veteran > 1) {OR ((Veteran <> 0) AND (Result <= alpha) AND (Schach <> 0)) {OR (favorisiert AND (Stillstand = 0))}))
      THEN BEGIN Inc(I); Inc(X) END;

      Ziel := -16384;
      IF I = 0 THEN
      BEGIN {- Ruhesuche: Gegner darf auszhlen -}
        Vergleich := Bewertung; {- Standardbewertung = inkrementelle Bewertung + Knigssicherheit -}
        Dec(Vergleich, Rex(@Analyse[Ebene+1], -1){$IFDEF Varianten}SHL Integer(Crazyhouse){$ENDIF});
        Inc(Vergleich, Rex(@Analyse[Ebene+1], 1){$IFDEF Varianten}SHL Integer(Crazyhouse){$ENDIF});

        {$IFDEF Varianten} IF NOT Crazyhouse THEN {$ENDIF} {- Spezialbewertungen fr Endspiele -}
          FOR Zielfigur := -1 TO 1 DO IF Zielfigur <> 0 THEN
          BEGIN
            Vergleich := Vergleich*Zielfigur;
            X1 := Material[Zielfigur]; X2 := Material[-Zielfigur];
            IF X1 < 256 THEN {NN, N, B erreichen gegen Bauern selten mehr als Remis}
              CASE X2 OF
                4096, 256: BEGIN Inc(Vergleich, 300); IF (Vergleich < 0) AND (X1 = 0) THEN Vergleich := 0 END;
                 512: BEGIN Inc(Vergleich, 600); IF (Vergleich < 0) AND (X1 = 0) THEN Vergleich := 0; END;
              END;
            IF X1 = 0 THEN
            BEGIN
              IF X2 > 4352 THEN Dec(Vergleich, 1024) {Gegner hat Offizier oder mehr als NB (NB reicht zwar meist, ist aber schwer zu spielen)}
              ELSE IF X2 AND 240 <> 0 THEN
              BEGIN {Gegner hat mindestens einen Bauern}
                FOR J := 119 DOWNTO 0 DO IF (J AND 136 = 0) AND (Br[J] = -Zielfigur) THEN
                BEGIN
                  IF Zielfigur*(KPos[Zielfigur] AND 7) > Zielfigur*(J AND 7)+Integer(dran <> Zielfigur)
                  THEN BEGIN Dec(Vergleich, 1024); Break END; {einsamer Knig vertikal abgehngt}
                  Ziel := J;
                  REPEAT
                    Dec(Ziel, Zielfigur);
                  UNTIL (Ziel AND 136 <> 0) OR (Br[Ziel] <> 0);
                  IF (Ziel AND 136 = 0) THEN Continue; {jemand blockiert den Bauern}
                  REPEAT
                    Inc(Ziel, Zielfigur);
                  UNTIL Sqr(Ziel AND 7-KPos[-Zielfigur] AND 7)+Sqr(Ziel SHR 4-KPos[-Zielfigur] SHR 4) > 2; {Ziel := letztes unsicheres Feld}
                  IF Abs(KPos[Zielfigur] SHR 4-Ziel SHR 4) > Zielfigur*(J-Ziel)+Integer(dran <> Zielfigur)
                  THEN BEGIN Dec(Vergleich, 768); Break END; {einsamer Knig horizontal abgehngt}
                END;
              END;
              IF X2 = 4352 THEN {KNBK: von gegnerischem Lufer kontrollierte Ecken sind Mattfallen}
              BEGIN
                FOR J := 119 DOWNTO 0 DO IF (J AND 136 = 0) AND (Abs(Br[J]) = L) THEN
                BEGIN
                  IF Odd(J) = Odd(J SHR 4) {Lufer auf schwarzem Feld?}
                  THEN Dec(Vergleich, Abs(KPos[Zielfigur] AND 7+KPos[Zielfigur] SHR 4-7) SHL 7)
                  ELSE Dec(Vergleich, Abs(KPos[Zielfigur] AND 7-KPos[Zielfigur] SHR 4) SHL 7);
                  Break
                END;
              END;
            END;
            IF Vergleich > 0 THEN {vermutlich unentschiedene Positionen, in denen die Zielfigur strker scheint, abwerten}
              IF ((X2 >= 256) AND ((X1 = 4352) OR (X1 = 8192) OR (X1 = 65536))) {KmmKm*, KRKm*}
              OR ((X2 >= 65536) AND ((X1 = 65536+256) OR (X1 = 65536+4096))) THEN Vergleich := Vergleich SHR 1; {KRmKR*}
            {leichte Gewinnstellungen aus KP*K einfgen: verbundene Bauern, verwandlungssichere Einzelbauern!}
            IF (X2 AND NOT 61680 = 0) AND (Vergleich < 0) THEN {Gegner scheint strker, hat aber nur Lufer und Bauern}
            BEGIN
              {Situation 1: unser Knig kontrolliert ein Eckfeld, das alle Bauern fngt und kein gegnerischer Lufer bedrohen kann}
               IF (KPos[Zielfigur]-2*Zielfigur) AND 8 <> 0 THEN
               BEGIN
                 Ziel := KPos[Zielfigur] SHR 4;
                 IF Ziel = 1 THEN Ziel := 0;
                 IF Ziel = 6 THEN Ziel := 7;
                 IF (Ziel = 0) OR (Ziel = 7) THEN
                 BEGIN
                   J := (X2 SHR 4) AND 15;
                   IF J <> 0 THEN
                     FOR Bauernrang := 7 DOWNTO 0 DO
                       IF Br[Ziel SHL 4+Bauernrang] = -Zielfigur THEN Dec(J);
                   IF J = 0 THEN {alle Bauern auf Zielanflug}
                   BEGIN
                     J := (X2 SHR 12) AND 15;
                     IF J <> 0 THEN
                       FOR Bauernrang := 119 DOWNTO 0 DO
                         IF (Bauernrang AND 136 = 0) AND (Br[Bauernrang] = (-L)*Zielfigur) THEN
                           IF Odd((Bauernrang SHR 4) XOR Bauernrang XOR Ziel XOR (Zielfigur SHR 1))
                           THEN Dec(J) ELSE Break;

                     IF J = 0 THEN Vergleich := -((X2 SHR 3+X2 SHR 8+X2 SHR 12) AND 15);
                   END;
                 END;
               END;
              {hilflose Bauernkolonnen als Unentschieden werten:}
              {Situation 2 (przisieren!): Knig opponiert Gegnerknig vor allen Bauern}
              {Situation 3 (przisieren!): Knig kontrolliert Randfeld, auf das alle Bauern zulaufen;
               gegnerischer Knig ist fern von den letzten drei Rngen}
            END;

            IF (X1 = 16) AND ((X2 = 1048576) OR (X2 = 65536)) THEN {typisches Unentschieden in KPKQ, gilt jeweils erst recht in KPKR}
            BEGIN
              Ziel := KPos[Zielfigur];
              IF ((Ziel+2*Zielfigur) AND 8 <> 0) THEN
              BEGIN
                J := 0; {steht der schwache Knig neben einer der hinteren Ecken?}
                IF Ziel < 48 THEN
                BEGIN
                  IF Ziel < 16 THEN J := Abs(Br[Ziel-2*Zielfigur+16]) OR Integer(dran <> Zielfigur) {Knig soll sich nur vor den Bauern stellen, wenn die Dame schrg hinter ihm lauert}
                  ELSE IF Ziel < 32 THEN J := 1 {direkt neben ihm ist es immer sicher}
                  ELSE IF (Ziel+Zielfigur) AND 8 = 0 THEN {Ausweichposition: zwei Felder seitlich vom Bauern}
                  BEGIN
                    IF (dran <> Zielfigur) AND (Abs(Br[7*Integer(Zielfigur=1)]) <> D) THEN J := 1 {wenn die Dame kein Zugrecht hat und nicht auf dem Ziel hockt}
                    ELSE FOR Bauernrang := 2 TO 6 DO IF Abs(Br[Ziel-16-Bauernrang*Zielfigur]) = D THEN J := 16; {oder die Springerspalte deckt}
                  END;
                  Ziel := 0;
                END;
                IF Ziel >= 80 THEN
                BEGIN
                  IF Ziel >= 112 THEN J := Abs(Br[Ziel-2*Zielfigur-16]) OR Integer(dran <> Zielfigur)
                  ELSE IF Ziel >= 96 THEN J := 1
                  ELSE IF (Ziel+Zielfigur) AND 8 = 0 THEN
                  BEGIN
                    IF (dran <> Zielfigur) AND (Abs(Br[112+7*Integer(Zielfigur=1)]) <> D) THEN J := 1
                    ELSE FOR Bauernrang := 2 TO 6 DO IF Abs(Br[Ziel+16-Bauernrang*Zielfigur]) = D THEN J := 16;
                  END;
                  Ziel := 112;
                END;
                IF Zielfigur = 1 THEN Inc(Ziel, 7);
                IF (KPos[Zielfigur] = Ziel) AND (Zahl[dran AND 8+Ziel XOR 16] <> 0) AND (Zahl[dran AND 8+Ziel XOR 16-Zielfigur] <> 0) AND (dran <> Zielfigur)
                THEN Vergleich := 42 {Wunschpatt}
                ELSE IF (J <> 0) AND (Abs(Br[Ziel-Zielfigur]) = B) THEN {Bauer steht direkt vor der Zielecke}
                BEGIN
                  J := 1 SHL Abs(KPos[-Zielfigur] AND 7-Ziel AND 7)+1 SHL Abs(KPos[-Zielfigur] SHR 4-Ziel SHR 4); {Abstand des starken Knigs}
                  IF J >= 32 THEN BEGIN Vergleich := -128; IF (J >= 36) OR (X2 = 65536) THEN Vergleich := 0 END;
                END;
              END;
            END;
            Vergleich := Vergleich*Zielfigur;
          END;
        Vergleich := Vergleich*dran;

        IF Zahl[Succ(dran) SHL 2+KPos[-dran]] <> 0 THEN BEGIN Inc(I); {Inc(X)} END;
        IF Vergleich < beta THEN
          IF (Vergleich <= Result) OR (Vergleich <= alpha) THEN
          BEGIN
            IF Vergleich > Result THEN IF Vergleich <= alpha THEN Result := Vergleich ELSE Result := alpha;
            IF I = 0 THEN BEGIN Merke(Vergleich, -1, 1); GOTO nichtSuchen END {Gegner steht zu gut}
          END
          ELSE MinWert := -Vergleich
        ELSE IF (Material[1] AND 255 > 16) AND (Material[-1] AND 255 > 16) {jeder hat mehr als einen Bauern ...}
        AND (Material[1] SHR 8 <> 0) AND (Material[-1] SHR 8 <> 0) {... und mindestens eine andere Figur}
        THEN Ziel := Vergleich-beta-192; {=> Situation nicht (Endspiel-)Bonus-kritisch}
      END;

      IF Result < alpha THEN MaxWert := -alpha ELSE MaxWert := -Result;
      {$IFDEF Zwei} IF (Ebene = 0) AND (Zwei <> 0) THEN
      BEGIN {$IFNDEF ZweiPlus} IF (Result > 16384) AND (Zwei > 1) THEN ZWert := Result; {$ENDIF} MaxWert := -ZWert END; {$ENDIF}

      Vergleich := 29998 + MaxWert; {wenn Matt gefunden, nur noch krzere Mattdistanzen erwgen}
      IF Vergleich <= 0 THEN Break; IF Vergleich < I THEN I := Vergleich;

      WITH Hirn[Integer(Merkwert) AND Hirnmaske] DO IF Merkwert = MW THEN
      BEGIN J := BestZug AND $FFFFFF; IF J <> 0 THEN Y := J END;
      Inc(MinWert, MinWert DIV 16384); Inc(MaxWert, MaxWert DIV 16384); {Mattabstand}

      IF (unscharf <> 0) AND (I > 1) AND (Vorurteil < -MaxWert) AND (Result > -16384) {unverzichtbare Bedingungen}
      AND (Stillstand <> 0) AND ((unscharf > 2) OR (X = 0)) AND ((unscharf > 1) OR (NOT favorisiert)) {AND (beta < 16384)} {opportune Bedingungen}
      THEN Vergleich := -Suche(Succ(Ebene), Pred(I), Pred(MaxWert), MaxWert, X, Y, false, 0)
      ELSE Vergleich := 32767;
      IF Vergleich > -MaxWert THEN Vergleich := -Suche(Succ(Ebene), I, MinWert, MaxWert, X, Y, (Ebene = 0) OR (Veteran <> 0), Ziel);
      IF Zustand AND (Stop OR Hintergrund OR unendlich) = Stop THEN Exit;
      IF Ebene = 0 THEN Zustand := Zustand OR HauptzugDurch;
      Dec(Vergleich, Vergleich DIV 16384); {Mattabstand}
    END;
    Notiere(Vergleich); IF Result >= beta THEN Exit;
    nichtSuchen: Inc(Anfang);
    IF (Ebene = 0) AND (jetztZug <> Hauptzug) AND (vergangen > Richtwert) THEN Zustand := Zustand OR Stop;
  END;

  IF (Tiefe > 0) AND (ZugZahl = 0) THEN
  BEGIN {sicher als Patt oder Matt erkannt}
    IF Schach > 0 THEN Result := -30000 ELSE Result := 0;
    Merke(-Result, 0, 0)
  END ELSE
    IF Result > alpha THEN
    BEGIN
      IF (Abs(Result) < 16384) OR (Abs(Result)+Tiefe >= 29998) THEN Merke(-Result, 0, 0)
      ELSE IF Result > 0 THEN Merke(-Result, -1, 0) ELSE Merke(-Result, 1, 0)
    END ELSE IF Result < 16384 THEN Merke(-Result, 1, 0);

  IF (Tiefe > 3) {$IFDEF Varianten} OR (Crazyhouse AND (Tiefe > 1)) {$ENDIF} THEN
  BEGIN
    Vergleich := vergangen;
    IF (Vergleich > Restzeit) OR ((HWert >= letztWert) AND (Vergleich > Richtwert SHL 1) AND (Zustand AND Hauptzugdurch = 0)) {Notbremse}
    {$IFDEF Zwei} OR ((Zwei <> 0) AND (Ebene = 0) AND (((ZWert < -16384) AND (Result > -16384)))) {$ENDIF} {erzwungener Zug}
    THEN Zustand := Zustand OR Stop;
  END;
END;

{----- III. Schnittstelle -----}

PROCEDURE Vergessen;
BEGIN
  IF gemerkt <> 0 THEN BEGIN FillChar(Hirn[0], Succ(Hirnmaske) SHL 4, #0); gemerkt := 0 END;
END;

PROCEDURE RechnerZug;

VAR St : String;
    Z, Rest, proZug, Suchtiefe : Integer;
    {$IFDEF Lernen} F : File; {$ENDIF}

BEGIN
  REPEAT
    proZug := 0; Restzeit := 0; Zustand := 0; WHILE Zustand <> Anfang DO Sleep(1);

    {Drucke(@Analyse[0]);}

    Rest := 40; Beginn := GetTickCount;
    WHILE Parameter <> '' DO
    BEGIN
      St := Entnimm(Parameter);
      IF Analyse[0].Anzug > 0 THEN
      BEGIN IF St = 'wtime' THEN Restzeit := StrToInt(Entnimm(Parameter)); IF St = 'winc' THEN proZug := StrToInt(Entnimm(Parameter)) END ELSE
      BEGIN IF St = 'btime' THEN Restzeit := StrToInt(Entnimm(Parameter)); IF St = 'binc' THEN proZug := StrToInt(Entnimm(Parameter)) END;
      IF St = 'movestogo' THEN Rest := StrToInt(Entnimm(Parameter));
      IF St = 'infinite' THEN Zustand := Zustand OR unendlich;
      IF St = 'ponder' THEN Zustand := Zustand OR Hintergrund;
    END;

    IF Restzeit < 65536 THEN Restzeit := Restzeit SHR 1 ELSE Dec(Restzeit, 32768);
    Grundwert := (Restzeit DIV Succ(Rest));
    Inc(Grundwert, proZug SHR 1); Richtwert := Grundwert;

    Knoten := 0; selektiv := 0; HauptZug := 0; Neuerung := 0;
    FOR SuchTiefe := 1 TO 255 DO
    BEGIN
      Zustand := Zustand AND NOT Hauptzugdurch; IF Suchtiefe = 1 THEN Zustand := Zustand OR Hauptzugdurch;
      {$IFDEF Zwei} ZweitZug := 0; ZWert := -32000; {$ENDIF}
      Z := Hauptzug;
      Suche(0, Suchtiefe, -32000, 32000, 0, Z, false, -16384);
      Zustand := Zustand OR rechne;
      IF ((Abs(HWert) >= 29998-Suchtiefe) {$IFDEF ZweiPlus} AND ((Zwei <= 1) OR (Abs(ZWert) >= 29998-Suchtiefe)) {$ENDIF}) THEN Break;

      {$IFDEF Zwei} IF (Succ(Suchtiefe) >= LetztTiefe) AND (Suchtiefe > Neuerung+2) {frher Abbruch bei "ziemlich klaren" Zgen}
      AND ( (ZWert < Letztwert-192) OR ((vergangen > Grundwert SHR 1) AND (ZWert < Letztwert-64)) )
      AND (Abs(HWert) < 512) AND (HWert > LetztWert-32) AND (HWert < LetztWert+64)
      THEN Zustand := Zustand OR Stop; {$ENDIF}
      IF ((vergangen > Grundwert) AND (HWert > LetztWert-16)) {moderate Zeitschranken bei begrenztem Verlust}
      OR ((vergangen > Grundwert SHL 1) AND ((HWert > LetztWert-64) OR (LetztTiefe = 255))) {Pauschale fr ersten eigenen Zug}
      OR (vergangen > Grundwert SHL 2) THEN Zustand := Zustand OR Stop;
      IF Zustand AND (Stop OR Hintergrund OR unendlich) = Stop THEN
      BEGIN
        IF vergangen > Grundwert THEN BEGIN LetztTiefe := Suchtiefe; LetztWert := HWert END;
        Break;
      END;
    END;
    WHILE Zustand AND (Anfang OR Hintergrund) <> 0 DO Sleep(1);
    Zustand := Stop;
    IF HauptZug <> 0 THEN
    BEGIN
      {$IFDEF Varianten} CASE Protokoll OF
        PUCI: BEGIN {$ENDIF}
          St := 'bestmove'+ZugName(HauptZug);
          Ziehe(0, Hauptzug);
          WITH Analyse[1], Hirn[Integer(Merkwert) AND Hirnmaske] DO
            IF Merkwert = MW THEN St := St+' ponder'+ZugName(BestZug AND $FFFFFF);
          Schreib(St);
          {$IFDEF ZweiPlus} IF (ZweitZug <> 0)
          THEN Schreib('info string'+PV(ZweitZug)+' '+Wertung(ZWert)); {$ENDIF}
          {$IFDEF Varianten}
        END;
        PWinboard: BEGIN
          Ziehe(0, Hauptzug);
          Schreib('move'+Zugname(Hauptzug));
          Analyse[0] := Analyse[1];
        END;
      END;
      {$ENDIF}
    END;
    {$IFDEF Lernen}
    IF (Analyse[0].Zugnummer = 12) AND (Status = 1) THEN
    BEGIN
      Inc(Status); AssignFile(F, Name); ReWrite(F, 1);
      BlockWrite(F, Hirn[0], Succ(Hirnmaske) SHL 4);
      CloseFile(F); Vergessen;
    END;
    {$ENDIF}

    WITH Analyse[0] DO {$IFDEF Lernen} IF Zugnummer > 12 THEN {$ENDIF}
    IF (Wahl AND Erinnerung = 0) OR ({$IFDEF Varianten} NOT Crazyhouse AND{$ENDIF}
    ((Stillstand > 80) OR (Material[1] = 0) OR (Material[-1] = 0))) THEN Vergessen;
    {Beispiel: ohne Amnesie scheitert KBNK regelmig daran, da alte Planungen Stellungen wiederholen}
  UNTIL False;
END;

PROCEDURE Hirnvolumen(MB : Integer);

VAR I : Integer;

BEGIN
  I := 1; WHILE I <= MB DO I := I SHL 1; I := I SHL 15; Hirnmaske := Pred(I);
  IF Hirn <> NIL THEN FreeMem(Hirn); GetMem(Hirn, I SHL 4); Vergessen;
END;

PROCEDURE UCI;

VAR Befehl, Kommando, S, T: String;
    Z, gelesen : Cardinal;
    C : Char;

  PROCEDURE Setze(S:String);

  BEGIN
    {$IFDEF Varianten} IF S[2] = '@' THEN BEGIN S := S+Char(Byte(S[1]) OR 32); PWord(@(S[1]))^ := 12641 END; {$ENDIF}
    Z := Ord(S[1]) SHL 4+Ord(S[2])+Ord(S[3]) SHL 12+Ord(S[4]) SHL 8-411457;
    IF Odd(Length(S)) THEN Inc(Zugtyp(Z).Erweiterung, Pos(S[5], englisch));
    Ziehe(0, Z); Analyse[0] := Analyse[1]
  END;

  PROCEDURE WBZug;

  BEGIN
    Parameter := 'wtime '+IntToStr(WZeit)+' btime '+IntToStr(SZeit);
    Zustand := Anfang;
    WHILE Zustand AND rechne = 0 DO Sleep(1);
    Zustand := Zustand AND NOT Anfang;
  END;

BEGIN
  REPEAT
    Befehl := '';
    REPEAT ReadFile(Eingabe, C, 1, gelesen, nil); Befehl := Befehl+C UNTIL C = #10;
    Kommando := Entnimm(Befehl);
    IF Zustand AND (Stop OR Hintergrund OR unendlich) = Stop THEN WHILE Zustand <> 0 DO Sleep(1);
    IF Kommando = 'quit' THEN Halt;

    IF Kommando = 'uci' THEN
    BEGIN
      Schreib('id name Feuerstein 0.4.5.2'{$IFDEF Varianten}+' VARIANT'{$ENDIF}+#10'id author Fritz Grau'#10+
         'option name Hash type spin default 32 min 1 max 512'#10+
{$IFDEF Zwei} 'option name 2nd type combo default on '+
{$IFDEF ZweiPlus} 'var full' {$ENDIF} + ' var on var off'#10+ {$ENDIF}
         'option name remember type check default true'#10+
         'option name extend check type check default true'#10+
         'option name extend force type combo default full var full var on var off'#10+
         'option name extend gambit type check default true'#10+
         'option name nullmove type check default true'#10+
         'option name blur type spin default 3 min 0 max 3'#10+
         'option name Ponder type check default true'#10'uciok');
      {$IFDEF Varianten} Protokoll := PUCI; {$ENDIF} MatWert := StdWert;
    END;

    {$IFDEF Varianten} IF Kommando = 'xboard' THEN BEGIN Protokoll := PWinboard; WinBoard := 0; END;

    IF Protokoll = PUCI THEN {$ENDIF}
    BEGIN
      IF (Kommando = 'stop') AND (Zustand <> 0) THEN
      BEGIN
        Zustand := Zustand OR Stop;
        Zustand := Zustand AND NOT (Hintergrund OR unendlich)
      END;
      IF Kommando = 'ponderhit' THEN Zustand := Zustand AND NOT (Hintergrund OR unendlich);
      IF Kommando = 'position' THEN
      BEGIN
        S := EntnimmBis(Befehl, 'moves');
        IF S = 'startpos' THEN FEN(Aufstellung)
        ELSE IF Entnimm(S) = 'fen' THEN FEN(S);
        WHILE Befehl <> '' DO Setze(Entnimm(Befehl));
      END;
      IF Kommando = 'setoption' THEN
        IF Entnimm(Befehl) = 'name' THEN
        BEGIN
          S := EntnimmBis(Befehl, 'value');
          IF S = 'Hash' THEN Hirnvolumen(StrToInt(Entnimm(Befehl)));
          {$IFDEF Zwei} IF S = '2nd' THEN
          BEGIN {Zwei := (6-Length(Befehl)) MOD 3;}
            IF Befehl = 'full' THEN Zwei := 2; IF Befehl = 'on' THEN Zwei := 1; IF Befehl = 'off' THEN Zwei := 0;
          END; {$ENDIF}
          IF S = 'remember' THEN IF Befehl = 'true' THEN Wahl := Wahl OR Erinnerung ELSE Wahl := Wahl AND NOT Erinnerung;
          IF S = 'nullmove' THEN IF Befehl = 'true' THEN Wahl := Wahl OR Nullzug ELSE Wahl := Wahl AND NOT Nullzug;
          IF S = 'blur' THEN unscharf := StrToInt(Befehl);
          T := Entnimm(S);
          IF T = 'extend' THEN
          BEGIN
            IF S = 'check' THEN IF Befehl = 'true' THEN Wahl := Wahl OR ESchach ELSE Wahl := Wahl AND NOT ESchach;
            IF S = 'force' THEN
            BEGIN
              IF Befehl = 'off' THEN Wahl := Wahl AND NOT (EDruck OR EZwang);
              IF Befehl = 'full' THEN Wahl := Wahl OR (EDruck OR EZwang);
              IF Befehl = 'on' THEN Wahl := Wahl AND NOT EDruck OR EZwang;
            END;
            IF S = 'gambit' THEN IF Befehl = 'true' THEN Wahl := Wahl OR EOpfer ELSE Wahl := Wahl AND NOT EOpfer;
          END;
        END;
      IF Kommando = 'ucinewgame' THEN BEGIN Vergessen; Letztwert := 0; LetztTiefe := 255; {$IFDEF Lernen} Status := 0; {$ENDIF} END;
      IF Kommando = 'isready' THEN Schreib('readyok');
      IF Kommando = 'go' THEN
      BEGIN
        Parameter := Befehl; Zustand := Anfang; WHILE Zustand AND rechne = 0 DO Sleep(1);
        Zustand := Zustand AND NOT Anfang;
      END;
    END;

    {$IFDEF Varianten}
    {Auswertung von WinBoard-Befehlen}
    IF Protokoll = PWinBoard THEN
    BEGIN
      (* IF Kommando = 'test' THEN
      BEGIN
        Crazyhouse := true; MatWert := ZhWert; Wahl := Wahl OR Nullzug; unscharf := 3;
        {FEN('r1b1kbnr/ppb1pppp/1qpp4/8/2BN4/2N1P3/PPP2PPP/R2Q1RK1/PN w kq - 0 0');}
        {FEN('r2knQ2/ppb1pBnp/1qppn2P/8/8/2N1P3/PPP2PPP/R4RK1/BBRpp w - - 0 0');}
        {FEN('r2knn2/ppb1pBPp/1qpp4/8/8/2N1P3/PPP2PPP/R4RK1/NBBRppq w - - 0 0');}
        {FEN('r2knQ~2/ppbqpB1p/1qpp4/8/8/2N1P3/PPP2PPP/R4RK1/NNBBRpp w - - 0 0');}
        {FEN('r1N2r1k/p2p1p1p/pq3p1p/8/1P6/P3P1B1/1pP2PPP/3nKBNR/PBnbrq b K - 0 0');}
        {FEN('rnbqk3/pp1pppNp/7P/7p/8/2N5/PPP2PrP/R1BQK2R/Bpppnb b KQq - 0 0');}
        FEN('2n1k2r/1r2npbp/2P3p1/4n3/4K3/Q1P1N3/PP1P1PPb/R1B1r3/PPPPPPBQ b k - 0 0');
        {FEN('2n2rk1/5pbp/2Pb2p1/Q1p5/5n2/2P1NK2/PP1P1PP1/R1B3r1/PPPPPBRQn b - - 0 0');}
        WZeit := 1000000000; SZeit := WZeit; WinBoard := WinBoard OR Ausgabe;
        Drucke(@Analyse[0]); Kommando := 'go';
      END; *)

      IF (Length(Kommando) >= 4) AND (Kommando[4] >= '1') AND (Kommando[4] <= '8')
      THEN BEGIN Befehl := Kommando; Kommando := 'usermove' END;

      IF Kommando = 'post' THEN Winboard := Winboard OR WAusgabe
      ELSE IF Kommando = 'nopost' THEN Winboard := Winboard AND NOT WAusgabe
      ELSE IF Kommando = 'hard' THEN Winboard := Winboard OR WHintergrund
      ELSE IF Kommando = 'easy' THEN Winboard := Winboard AND NOT WHintergrund
      ELSE IF Kommando = 'force' THEN Winboard := Winboard OR WPassiv
      ELSE IF (Kommando = 'time') OR (Kommando = 'otim') THEN
      BEGIN
        IF (Kommando[1] = 'o') XOR (Analyse[0].Anzug = -1)
        THEN WZeit := StrToInt(Befehl)*10
        ELSE SZeit := StrToInt(Befehl)*10;
      END
      ELSE IF Kommando = 'new' THEN
      BEGIN
        Winboard := Winboard AND NOT WPassiv; {$IFDEF Lernen} Status := 0; {$ENDIF}
        MatWert := StdWert; Vergessen; FEN(Aufstellung);
        Letztwert := 0; {$IFDEF Varianten} Crazyhouse := false; {$ENDIF}
      END
      ELSE IF Kommando = 'variant' THEN
      BEGIN
        {$IFDEF Varianten}
        IF Befehl = 'crazyhouse' THEN
        BEGIN
          Crazyhouse := true; MatWert := ZhWert; Wahl := Wahl OR Nullzug; unscharf := 3;
          {$IFDEF Lernen} Status := 0; {$ENDIF} Vergessen; FEN(Aufstellung); Letztwert := 0; Winboard := Winboard AND NOT WPassiv;
        END;
        {$ENDIF}
      END
      ELSE IF Kommando = 'setboard' THEN FEN(Befehl)
      ELSE IF Kommando = 'go' THEN
      BEGIN Winboard := Winboard AND NOT WPassiv; WBZug END
      ELSE IF Kommando = 'protover' THEN Schreib('feature myname="Feuerstein" colors=0 usermove=1 setboard=1 analyze=1 done=1')
      ELSE IF Kommando = 'analyze' THEN
      BEGIN
        Parameter := 'infinite'; Zustand := Anfang; WHILE Zustand AND rechne = 0 DO Sleep(1);
        Zustand := Zustand AND NOT Anfang;
      END
      ELSE IF (Kommando = 'exit') AND (Zustand <> 0) THEN
      BEGIN Zustand := Zustand OR Stop; Zustand := Zustand AND NOT (Hintergrund OR unendlich) END
      ELSE IF Kommando = 'usermove' THEN
      BEGIN Setze(Befehl); IF Winboard AND WPassiv = 0 THEN WBZug END
      ELSE
      IF (Kommando <> 'accepted') AND (Kommando <> 'random') AND (Kommando <> 'xboard') AND (Kommando <> 'computer')
      THEN Schreib('unknown command: '+Kommando);
    END;
    {$ENDIF}
  UNTIL false;
END;

BEGIN
  Ausgabe := GetStdHandle(std_output_handle); Eingabe := GetStdHandle(std_input_handle);
  Hirn := nil; Hirnvolumen(32); New(Analyse);
  FOR X := High(Zob) DOWNTO 0 DO Zob[X] := Random(65536);
  {$IFDEF Zwei} Zwei := 1; {$ENDIF} Wahl := EZwang OR ESchach OR EOpfer OR EDruck OR Erinnerung OR Nullzug;
  unscharf := 3; {$IFDEF Varianten} Protokoll := 0; Crazyhouse := false; {$ENDIF}
  BeginThread(nil, 0, @UCI, nil, 0, X);
  {CreateThread verkrzt das Programm deutlich, scheint bei einigen Prozessoren aber zu Fehlern zu fhren}
  Rechnerzug
END.